/*Canopy - The next generation of stoner streaming software
Copyright (C) 2024-2025 Rainbownapkin and the TTN Community

This program is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as
published by the Free Software Foundation, either version 3 of the
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with this program.  If not, see <https://www.gnu.org/licenses/>.*/

//npm imports
const {validationResult, matchedData} = require('express-validator');

//local imports
const {userModel} = require('../../../schemas/user/userSchema');
const accountUtils = require('../../../utils/sessionUtils');
const {exceptionHandler, errorHandler} = require('../../../utils/loggerUtils');

//api account functions
module.exports.post = async function(req, res){
    try{
        const validResult = validationResult(req);

        if(validResult.isEmpty()){
            //syntactic sugar :P
            const user = req.session.user;
            const data = matchedData(req);

            //make sure we're not bullshitting ourselves here.
            if(user == null){
                res.status(400);
                return res.send('Invalid Session! Cannot delete account while logged out!'); 
            }

            const userDB = await userModel.findOne(user);


            if(!userDB){
                res.status(400);
                return res.send('Invalid User! Account must exist in order to delete!');
            }

            await userDB.nuke(data.pass);
            accountUtils.killSession(req.session);
            return res.sendStatus(200);
        }else{
            res.status(400);
            res.send({errors: validResult.array()})
        }
    }catch(err){
        exceptionHandler(res, err);
    }
    
}